module Nadir
  class Sidekiq
    def self.notify(exception, context)
      if context[:job]['class'] == 'ActiveJob::QueueAdapters::SidekiqAdapter::JobWrapper'
        job_params = {
          class: context[:job]['args'].first['job_class'],
          args: context[:job]['args'].first['arguments'],
          queue: context[:job]['args'].first['queue_name'],
          job_id: context[:job]['args'].first['job_id'],
          retry_count: context[:job]['retry_count'],
          jid: context[:job]['jid'],
        }
        location = job_params[:class]
      else
        job_params = context[:job].slice('class', 'args', 'retry_count', 'queue', 'jid')
        location = job_params['class']
      end

      Nadir.notify exception, job: job_params, location: location
    end
  end
end

::Sidekiq.configure_server do |config|
  config.error_handlers << Proc.new { |ex,ctx_hash| Nadir::Sidekiq.notify(ex, ctx_hash) }
end
